io.vertx.core.buffer

## Interface Buffer

- All Superinterfaces:
    io.vertx.core.shareddata.impl.ClusterSerializable

      public interface Buffer
      extends io.vertx.core.shareddata.impl.ClusterSerializable

  Most data is shuffled around inside Vert.x using buffers.

  A buffer is a sequence of zero or more bytes that can read from or written to and which expands automatically as necessary to accommodate any bytes written to it. You can perhaps think of a buffer as smart byte array.

  Please consult the documentation for more information on buffers.

  Author:
    Tim Fox

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static BufferFactory` | `factory`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `Buffer` | `appendBuffer(Buffer buff)` Appends the specified `Buffer` to the end of this Buffer.
    `Buffer` | `appendBuffer(Buffer buff, int offset, int len)` Appends the specified `Buffer` starting at the `offset` using `len` to the end of this Buffer.
    `Buffer` | `appendByte(byte b)` Appends the specified `byte` to the end of the Buffer.
    `Buffer` | `appendBytes(byte[] bytes)` Appends the specified `byte[]` to the end of the Buffer.
    `Buffer` | `appendBytes(byte[] bytes, int offset, int len)` Appends the specified number of bytes from `byte[]` to the end of the Buffer, starting at the given offset.
    `Buffer` | `appendDouble(double d)` Appends the specified `double` to the end of the Buffer.
    `Buffer` | `appendFloat(float f)` Appends the specified `float` to the end of the Buffer.
    `Buffer` | `appendInt(int i)` Appends the specified `int` to the end of the Buffer.
    `Buffer` | `appendLong(long l)` Appends the specified `long` to the end of the Buffer.
    `Buffer` | `appendShort(short s)` Appends the specified `short` to the end of the Buffer.The buffer will expand as necessary to accommodate any bytes written.
    `Buffer` | `appendString(String str)` Appends the specified `String str` to the end of the Buffer with UTF-8 encoding.
    `Buffer` | `appendString(String str, String enc)` Appends the specified `String` to the end of the Buffer with the encoding as specified by `enc`.
    `static Buffer` | `buffer()` Create a new, empty buffer.
    `static Buffer` | `buffer(byte[] bytes)` Create a new buffer from a byte[].
    `static Buffer` | `buffer(io.netty.buffer.ByteBuf byteBuf)` Create a new buffer from a Netty `ByteBuf`.
    `static Buffer` | `buffer(int initialSizeHint)` Create a new buffer given the initial size hint.
    `static Buffer` | `buffer(String string)` Create a new buffer from a string.
    `static Buffer` | `buffer(String string, String enc)` Create a new buffer from a string and using the specified encoding.
    `Buffer` | `copy()` Returns a copy of the entire Buffer.
    `Buffer` | `getBuffer(int start, int end)` Returns a copy of a sub-sequence the Buffer as a `Buffer` starting at position `start` and ending at position `end - 1`
    `byte` | `getByte(int pos)` Returns the `byte` at position `pos` in the Buffer.
    `io.netty.buffer.ByteBuf` | `getByteBuf()` Returns the Buffer as a Netty `ByteBuf`.
    `byte[]` | `getBytes()` Returns a copy of the entire Buffer as a `byte[]`
    `byte[]` | `getBytes(int start, int end)` Returns a copy of a sub-sequence the Buffer as a `byte[]` starting at position `start` and ending at position `end - 1`
    `double` | `getDouble(int pos)` Returns the `double` at position `pos` in the Buffer.
    `float` | `getFloat(int pos)` Returns the `float` at position `pos` in the Buffer.
    `int` | `getInt(int pos)` Returns the `int` at position `pos` in the Buffer.
    `long` | `getLong(int pos)` Returns the `long` at position `pos` in the Buffer.
    `short` | `getShort(int pos)` Returns the `short` at position `pos` in the Buffer.
    `String` | `getString(int start, int end)` Returns a copy of a sub-sequence the Buffer as a `String` starting at position `start` and ending at position `end - 1` interpreted as a String in UTF-8 encoding
    `String` | `getString(int start, int end, String enc)` Returns a copy of a sub-sequence the Buffer as a `String` starting at position `start` and ending at position `end - 1` interpreted as a String in the specified encoding
    `int` | `length()` Returns the length of the buffer, measured in bytes.
    `Buffer` | `setBuffer(int pos, Buffer b)` Sets the bytes at position `pos` in the Buffer to the bytes represented by the `Buffer b`.
    `Buffer` | `setBuffer(int pos, Buffer b, int offset, int len)` Sets the bytes at position `pos` in the Buffer to the bytes represented by the `Buffer b` on the given `offset` and `len`.
    `Buffer` | `setByte(int pos, byte b)` Sets the `byte` at position `pos` in the Buffer to the value `b`.
    `Buffer` | `setBytes(int pos, byte[] b)` Sets the bytes at position `pos` in the Buffer to the bytes represented by the `byte[] b`.
    `Buffer` | `setBytes(int pos, byte[] b, int offset, int len)` Sets the given number of bytes at position `pos` in the Buffer to the bytes represented by the `byte[] b`.
    `Buffer` | `setBytes(int pos, ByteBuffer b)` Sets the bytes at position `pos` in the Buffer to the bytes represented by the `ByteBuffer b`.
    `Buffer` | `setDouble(int pos, double d)` Sets the `double` at position `pos` in the Buffer to the value `d`.
    `Buffer` | `setFloat(int pos, float f)` Sets the `float` at position `pos` in the Buffer to the value `f`.
    `Buffer` | `setInt(int pos, int i)` Sets the `int` at position `pos` in the Buffer to the value `i`.
    `Buffer` | `setLong(int pos, long l)` Sets the `long` at position `pos` in the Buffer to the value `l`.
    `Buffer` | `setShort(int pos, short s)` Sets the `short` at position `pos` in the Buffer to the value `s`.
    `Buffer` | `setString(int pos, String str)` Sets the bytes at position `pos` in the Buffer to the value of `str` encoded in UTF-8.
    `Buffer` | `setString(int pos, String str, String enc)` Sets the bytes at position `pos` in the Buffer to the value of `str` encoded in encoding `enc`.
    `Buffer` | `slice()` Returns a slice of this buffer.
    `Buffer` | `slice(int start, int end)` Returns a slice of this buffer.
    `String` | `toString(String enc)` Returns a `String` representation of the Buffer with the encoding specified by `enc`

    - ### Methods inherited from interface io.vertx.core.shareddata.impl.ClusterSerializable

      `readFromBuffer, writeToBuffer`

- - ### Field Detail

    - #### factory

          static final BufferFactory factory

  - ### Method Detail

    - #### buffer

          static Buffer buffer()

      Create a new, empty buffer.
      Returns:
        the buffer

    - #### buffer

          static Buffer buffer(int initialSizeHint)

      Create a new buffer given the initial size hint.

      If you know the buffer will require a certain size, providing the hint can prevent unnecessary re-allocations as the buffer is written to and resized.

      Parameters:
        `initialSizeHint` - the hint, in bytes
      Returns:
        the buffer

    - #### buffer

          static Buffer buffer(String string)

      Create a new buffer from a string. The string will be UTF-8 encoded into the buffer.
      Parameters:
        `string` - the string
      Returns:
        the buffer

    - #### buffer

          static Buffer buffer(String string,
                               String enc)

      Create a new buffer from a string and using the specified encoding. The string will be encoded into the buffer using the specified encoding.
      Parameters:
        `string` - the string
      Returns:
        the buffer

    - #### buffer

          static Buffer buffer(byte[] bytes)

      Create a new buffer from a byte[]. The byte[] will be copied to form the buffer.
      Parameters:
        `bytes` - the byte array
      Returns:
        the buffer

    - #### buffer

          static Buffer buffer(io.netty.buffer.ByteBuf byteBuf)

      Create a new buffer from a Netty `ByteBuf`.
      Parameters:
        `byteBuf` - the Netty ByteBuf
      Returns:
        the buffer

    - #### toString

          String toString(String enc)

      Returns a `String` representation of the Buffer with the encoding specified by `enc`

    - #### getByte

          byte getByte(int pos)

      Returns the `byte` at position `pos` in the Buffer.
      Throws:
        `IndexOutOfBoundsException` - if the specified `pos` is less than `0` or `pos + 1` is greater than the length of the Buffer.

    - #### getInt

          int getInt(int pos)

      Returns the `int` at position `pos` in the Buffer.
      Throws:
        `IndexOutOfBoundsException` - if the specified `pos` is less than `0` or `pos + 4` is greater than the length of the Buffer.

    - #### getLong

          long getLong(int pos)

      Returns the `long` at position `pos` in the Buffer.
      Throws:
        `IndexOutOfBoundsException` - if the specified `pos` is less than `0` or `pos + 8` is greater than the length of the Buffer.

    - #### getDouble

          double getDouble(int pos)

      Returns the `double` at position `pos` in the Buffer.
      Throws:
        `IndexOutOfBoundsException` - if the specified `pos` is less than `0` or `pos + 8` is greater than the length of the Buffer.

    - #### getFloat

          float getFloat(int pos)

      Returns the `float` at position `pos` in the Buffer.
      Throws:
        `IndexOutOfBoundsException` - if the specified `pos` is less than `0` or `pos + 4` is greater than the length of the Buffer.

    - #### getShort

          short getShort(int pos)

      Returns the `short` at position `pos` in the Buffer.
      Throws:
        `IndexOutOfBoundsException` - if the specified `pos` is less than `0` or `pos + 2` is greater than the length of the Buffer.

    - #### getBytes

          byte[] getBytes()

      Returns a copy of the entire Buffer as a `byte[]`

    - #### getBytes

          byte[] getBytes(int start,
                          int end)

      Returns a copy of a sub-sequence the Buffer as a `byte[]` starting at position `start` and ending at position `end - 1`

    - #### getBuffer

          Buffer getBuffer(int start,
                           int end)

      Returns a copy of a sub-sequence the Buffer as a `Buffer` starting at position `start` and ending at position `end - 1`

    - #### getString

          String getString(int start,
                           int end,
                           String enc)

      Returns a copy of a sub-sequence the Buffer as a `String` starting at position `start` and ending at position `end - 1` interpreted as a String in the specified encoding

    - #### getString

          String getString(int start,
                           int end)

      Returns a copy of a sub-sequence the Buffer as a `String` starting at position `start` and ending at position `end - 1` interpreted as a String in UTF-8 encoding

    - #### appendBuffer

          Buffer appendBuffer(Buffer buff)

      Appends the specified `Buffer` to the end of this Buffer. The buffer will expand as necessary to accommodate any bytes written.

      Returns a reference to `this` so multiple operations can be appended together.

    - #### appendBuffer

          Buffer appendBuffer(Buffer buff,
                              int offset,
                              int len)

      Appends the specified `Buffer` starting at the `offset` using `len` to the end of this Buffer. The buffer will expand as necessary to accommodate any bytes written.

      Returns a reference to `this` so multiple operations can be appended together.

    - #### appendBytes

          Buffer appendBytes(byte[] bytes)

      Appends the specified `byte[]` to the end of the Buffer. The buffer will expand as necessary to accommodate any bytes written.

      Returns a reference to `this` so multiple operations can be appended together.

    - #### appendBytes

          Buffer appendBytes(byte[] bytes,
                             int offset,
                             int len)

      Appends the specified number of bytes from `byte[]` to the end of the Buffer, starting at the given offset. The buffer will expand as necessary to accommodate any bytes written.

      Returns a reference to `this` so multiple operations can be appended together.

    - #### appendByte

          Buffer appendByte(byte b)

      Appends the specified `byte` to the end of the Buffer. The buffer will expand as necessary to accommodate any bytes written.

      Returns a reference to `this` so multiple operations can be appended together.

    - #### appendInt

          Buffer appendInt(int i)

      Appends the specified `int` to the end of the Buffer. The buffer will expand as necessary to accommodate any bytes written.

      Returns a reference to `this` so multiple operations can be appended together.

    - #### appendLong

          Buffer appendLong(long l)

      Appends the specified `long` to the end of the Buffer. The buffer will expand as necessary to accommodate any bytes written.

      Returns a reference to `this` so multiple operations can be appended together.

    - #### appendShort

          Buffer appendShort(short s)

      Appends the specified `short` to the end of the Buffer.The buffer will expand as necessary to accommodate any bytes written.

      Returns a reference to `this` so multiple operations can be appended together.

    - #### appendFloat

          Buffer appendFloat(float f)

      Appends the specified `float` to the end of the Buffer. The buffer will expand as necessary to accommodate any bytes written.

      Returns a reference to `this` so multiple operations can be appended together.

    - #### appendDouble

          Buffer appendDouble(double d)

      Appends the specified `double` to the end of the Buffer. The buffer will expand as necessary to accommodate any bytes written.

      Returns a reference to `this` so multiple operations can be appended together.

    - #### appendString

          Buffer appendString(String str,
                              String enc)

      Appends the specified `String` to the end of the Buffer with the encoding as specified by `enc`.

      The buffer will expand as necessary to accommodate any bytes written.

      Returns a reference to `this` so multiple operations can be appended together.

    - #### appendString

          Buffer appendString(String str)

      Appends the specified `String str` to the end of the Buffer with UTF-8 encoding.

      The buffer will expand as necessary to accommodate any bytes written.

      Returns a reference to `this` so multiple operations can be appended together

    - #### setByte

          Buffer setByte(int pos,
                         byte b)

      Sets the `byte` at position `pos` in the Buffer to the value `b`.

      The buffer will expand as necessary to accommodate any value written.

    - #### setInt

          Buffer setInt(int pos,
                        int i)

      Sets the `int` at position `pos` in the Buffer to the value `i`.

      The buffer will expand as necessary to accommodate any value written.

    - #### setLong

          Buffer setLong(int pos,
                         long l)

      Sets the `long` at position `pos` in the Buffer to the value `l`.

      The buffer will expand as necessary to accommodate any value written.

    - #### setDouble

          Buffer setDouble(int pos,
                           double d)

      Sets the `double` at position `pos` in the Buffer to the value `d`.

      The buffer will expand as necessary to accommodate any value written.

    - #### setFloat

          Buffer setFloat(int pos,
                          float f)

      Sets the `float` at position `pos` in the Buffer to the value `f`.

      The buffer will expand as necessary to accommodate any value written.

    - #### setShort

          Buffer setShort(int pos,
                          short s)

      Sets the `short` at position `pos` in the Buffer to the value `s`.

      The buffer will expand as necessary to accommodate any value written.

    - #### setBuffer

          Buffer setBuffer(int pos,
                           Buffer b)

      Sets the bytes at position `pos` in the Buffer to the bytes represented by the `Buffer b`.

      The buffer will expand as necessary to accommodate any value written.

    - #### setBuffer

          Buffer setBuffer(int pos,
                           Buffer b,
                           int offset,
                           int len)

      Sets the bytes at position `pos` in the Buffer to the bytes represented by the `Buffer b` on the given `offset` and `len`.

      The buffer will expand as necessary to accommodate any value written.

    - #### setBytes

          Buffer setBytes(int pos,
                          ByteBuffer b)

      Sets the bytes at position `pos` in the Buffer to the bytes represented by the `ByteBuffer b`.

      The buffer will expand as necessary to accommodate any value written.

    - #### setBytes

          Buffer setBytes(int pos,
                          byte[] b)

      Sets the bytes at position `pos` in the Buffer to the bytes represented by the `byte[] b`.

      The buffer will expand as necessary to accommodate any value written.

    - #### setBytes

          Buffer setBytes(int pos,
                          byte[] b,
                          int offset,
                          int len)

      Sets the given number of bytes at position `pos` in the Buffer to the bytes represented by the `byte[] b`.

      The buffer will expand as necessary to accommodate any value written.

    - #### setString

          Buffer setString(int pos,
                           String str)

      Sets the bytes at position `pos` in the Buffer to the value of `str` encoded in UTF-8.

      The buffer will expand as necessary to accommodate any value written.

    - #### setString

          Buffer setString(int pos,
                           String str,
                           String enc)

      Sets the bytes at position `pos` in the Buffer to the value of `str` encoded in encoding `enc`.

      The buffer will expand as necessary to accommodate any value written.

    - #### length

          int length()

      Returns the length of the buffer, measured in bytes. All positions are indexed from zero.

    - #### copy

          Buffer copy()

      Returns a copy of the entire Buffer.

    - #### slice

          Buffer slice()

      Returns a slice of this buffer. Modifying the content of the returned buffer or this buffer affects each other's content while they maintain separate indexes and marks.

    - #### slice

          Buffer slice(int start,
                       int end)

      Returns a slice of this buffer. Modifying the content of the returned buffer or this buffer affects each other's content while they maintain separate indexes and marks.

    - #### getByteBuf

          io.netty.buffer.ByteBuf getByteBuf()

      Returns the Buffer as a Netty `ByteBuf`.

      This method is meant for internal use only.

Copyright © 2015. All Rights Reserved.